let pic = '';//截图
let pagestatus = '';//页面show状态
let txtarea = document.querySelector(".content-txt");
let nonet = document.querySelector(".nonet");
let copyToast = document.querySelector(".copy-toast");
let txtOperate = document.querySelector(".text-operate");
let editOperate = document.querySelector(".edit-operate");
let txtAreaValue;//原始识别内容
var sbox_w = '';//图片原始宽
var pcmVersion='';//管家版本
var from='';//来源
var isRightKey = false;//是否可以右键
var dragFlag = false;
window.onload = () => {
  initBigdata();
  //设置文本域只读属性
  txtarea.setAttribute("readonly", "readonly");
  //框架通知 命令行
  window.pcmjssdk.registerNativeNotify('FRAMEWORK_', (category, content) => {
    if (category == 'FRAMEWORK_COMMANDLINE') {
      console.log('收到命令行参数___:', content)
      pic = getParamFromCommandLine(content,'--imgpath=');
      let startmode = getParamFromCommandLine(content,'--startmode=');
      console.log(pic,startmode,"cmdline")
      if (pic) {
        console.log(window.pcmjssdk.commonMethod.fiterFilePath(pic),"转换")
        //展示截图
        document.querySelector(".divMove").src=window.pcmjssdk.commonMethod.fiterFilePath(pic);
        sbox_w = document.querySelector(".divMove").width;
        init();
      }
      if (startmode) {
        //0：默认截图1：长截图
        from = Number(startmode)+1+'';
      }
    }
    else if (category == 'FRAMEWORK_NOTIFY') {
      console.log('识别截图的文字:', JSON.parse(content));
      content = JSON.parse(content);
      let txt = '';
      if (content.is_ok) {
        if (content.result.hasOwnProperty('words_result')) {
          if (content.result.words_result.length>0) {
            content.result.words_result.forEach(item => {
              txt+=item.words+'\n';
            });
            txtOperate.classList.remove('disable');
            txtarea.classList.remove('loading');
            txtarea.innerHTML = txt;
            pagestatus='3';
          }else{
            txtarea.innerHTML = '无识别内容，请重新截图';
            txtarea.classList.add('loading');
            txtOperate.classList.add('disable');
            pagestatus='2';
          }
        }else if (content.result.hasOwnProperty('error_code')) {
          txtarea.classList.add('loading');
          txtOperate.classList.add('disable');
          if (content.result.error_code=='216202') {
            txtarea.innerHTML = '当前图片超出标准大小，请重新截图';
            pagestatus = '4';
          }else{
            txtarea.innerHTML = '识别失败，请重新截图';
            pagestatus = '5';
          }
        }
        reportBigdata({ category: 'show', action: 'SC3001', label: 'screencap',data:[{ key: 'pcm_version', value: pcmVersion },{ key: 'from', value: from },{ key: 'name', value: pagestatus }]});
      }
  }
  });
}
//初始化大数据
function initBigdata() {
  window.pcmjssdk.commonMethod.initBigdata();
}
//大数据上报方法
function reportBigdata(reportdata) {
  // var reportdata = { category: 'category', action: 'action', label: 'label', data: [{ key: 'key1', value: 'val1' }, { key: 'key2', value: 'val2' }] }
  window.pcmjssdk.commonMethod.reportBigdata(JSON.stringify(reportdata)).then(() => { })
}
// Utils function
function FormatTouchToString(event) {
  if (event.touches.length > 1)
    throw 'not support mutil touches point';
  return '' + (event.touches[0].clientX) + ';' + (event.touches[0].clientY);
}

function startMoveWindow(event) {
  getParent(event.target);
  if (!dragFlag) {
    window.pcmjssdk.commonMethod.startMoveWindow().then((e) => { })
  }
}
function touchStartDragWindow(event) {
  try {
    window.pcmjssdk.commonMethod.touchStartDragWindow(FormatTouchToString(event)).then((e) => { })
  } catch (error) {

  }
}
function touchMoveDragWindow(event) {
  try {
    window.pcmjssdk.commonMethod.touchMoveDragWindow(FormatTouchToString(event)).then((e) => {  })
  } catch (error) {

  }
}
function minimizeWindow() {
  window.pcmjssdk.commonMethod.minimizeWindow().then((e) => {  });
  reportBigdata({ category: 'click', action: 'SC3007', label: 'screencap',data:[{ key: 'pcm_version', value: pcmVersion },{ key: 'status', value: 'minimize' }]})
}
function closeWindow() {
  reportBigdata({ category: 'click', action: 'SC3007', label: 'screencap',data:[{ key: 'pcm_version', value: pcmVersion },{ key: 'status', value: 'close' }]})
  window.pcmjssdk.commonMethod.closeWindow().then((e) => { });
}

function getParamFromCommandLine(cmdline, key) {
  let val = '';
  if (cmdline.indexOf(key) >= 0) {
      val = cmdline.substring(cmdline.indexOf(key) + key.length);
      if (val.indexOf('--') >= 0) {
          val = val.substring(0, val.indexOf('--')).trim();
      }
  }
  return val;
}

function init(){
  txtarea.innerHTML = '正在加载中...';
  txtOperate.classList.add('disable');
  txtarea.style.display = 'block';
  txtarea.classList.add('loading');
  window.pcmjssdk.asyncBrowerQuery('GetNetState').then(res=>{
    pcmVersion = window.pcmjssdk.commonMethod.GetVersion();
    console.log("网络信息",res,pcmVersion)
    if (res && res==1) {
      nonet.style.display = 'none';
      //识图取字
      window.pcmjssdk.asyncBrowerQuery('OcrImg', pic);
    }else{
      txtOperate.classList.add('disable');
      pagestatus='1';
      txtarea.style.display = 'none';
      nonet.style.display = 'block';
    }
  })
}

function timeout(){
  setTimeout(()=>{
  copyToast.style.display = 'none';
  },3000)
}

function selectedCopy(text){
  var textarea = document.createElement('textarea');
  document.body.appendChild(textarea);
  // 隐藏此输入框
  textarea.style.position = 'fixed';
  textarea.style.clip = 'rect(0 0 0 0)';
  textarea.style.top = '10px';
  // 赋值
  textarea.value = text;
  // 选中
  textarea.select();
  // 复制
  document.execCommand('copy');
  // 移除输入框
  document.body.removeChild(textarea);
}

function copyText(){
  var selecedText = window.getSelection().toString();
  if (selecedText) {//选中
    selectedCopy(selecedText);
  } else {//未选中
    txtarea.select();
    document.execCommand("copy");
  }
  reportBigdata({ category: 'click', action: 'SC3005', label: 'screencap',data:[{ key: 'pcm_version', value: pcmVersion }]});
  //清除选中样式
  window.getSelection().removeAllRanges();
  copyToast.style.display = 'block';
  timeout();
}

function copyPic(){
  window.pcmjssdk.asyncBrowerQuery('CopyImg', pic);
  copyToast.style.display = 'block';
  timeout();
  reportBigdata({ category: 'click', action: 'SC3002', label: 'screencap',data:[{ key: 'pcm_version', value: pcmVersion }]})
}

function refresh(){
  nonet.style.display = 'none';
  init();
}

function editText(){
  txtAreaValue = txtarea.value;
  txtarea.removeAttribute("readonly");//文本域可读写
  txtOperate.style.display = 'none';
  editOperate.style.display = 'block';
  reportBigdata({ category: 'click', action: 'SC3004', label: 'screencap',data:[{ key: 'pcm_version', value: pcmVersion }]})
}

function outTextEdit(){
  txtarea.setAttribute("readonly", "readonly");
  txtOperate.style.display = 'block';
  editOperate.style.display = 'none';
}

function cancel(){
  outTextEdit();
  txtarea.value = txtAreaValue;
}

function confirm(){
  outTextEdit();
}
//右键 菜单
var menu = document.querySelector(".right-menu");
document.oncontextmenu = function(ev) {
  var ev = ev || event;
  if (window.getSelection().toString() && ev.target.id=='textarea') {
    menu.style.display = "block";
    menu.style.left = ev.clientX + "px";
    menu.style.top = ev.clientY + "px";
  }
  //阻止默认右键事件
  return false;
}
document.onclick = function(e) {
  //关闭右键菜单
  menu.style.display = "none";
}
//右键复制
function rightCopy (){
  selectedCopy(window.getSelection().toString());
  reportBigdata({ category: 'click', action: 'SC3006', label: 'screencap',data:[{ key: 'pcm_version', value: pcmVersion }]})
}
function getParent (node) {
  dragFlag = false;
  if (node.className.indexOf('nodrag') >= 0) {
    dragFlag = true;
    return
  } else {
    node = node.parentNode;
  }
  if (node.className !== 'ocr-header') {
    if (node.className.indexOf('nodrag') >= 0) {
     dragFlag = true;
    } else {
      getParent(node);
    }
  }
}